<template>
  <div
    class="ui-input flex items-center cursor-text justify-between gap-3 px-5 bg-btnlsec dark:bg-btndsec hover:bg-btnlsechpv dark:bg-btndsechov hover:shadow-inplhov dark:hover:shadow-inpdhov focus-within:bg-bglprim dark:focus-within:bg-bgdprim hover:focus-within:shadow-inplfoc dark:hover:focus-within:shadow-inpdfoc focus-within:shadow-inpdfoc"
    :class="[`h-${inputHeight}`, `rounded-${inputRadius}`]"
    @click="focusInput"
  >
    <slot />
    <input
      ref="input"
      :placeholder="placeholder"
      :value="value"
      @input="handleInput"
      class="bg-transparent flex-1 outline-none text-txtlprim dark:text-txtdprim font-medium"
    />
    <slot name="right" />
  </div>
</template>

<script>
export default {
  name: 'UiInput',

  props: {
    placeholder: {
      type: String,
      default: 'Type value...',
    },

    value: {
      type: String,
      default: '',
    },

    inputHeight: {
      type: [String, Number],
      default: '16',
    },

    inputRadius: {
      type: [String, Number],
      default: '24',
    },

    maxLength: {
      type: [String, Number],
      default: 'none',
    },
  },

  methods: {
    focusInput() {
      this.$refs.input.focus();
    },

    handleInput(event) {
      if (this.maxLength === 'none') {
        this.$emit('input', event.target.value);
      } else {
        this.$emit('input', '');
        this.$emit('input', event.target.value.slice(0, this.maxLength));
      }
    },
  },
};
</script>

<style lang="scss" scoped>
.ui-input {
  // transition: box-shadow 0.2s linear;

  input,
  textarea {
    caret-color: #0066ff;
    &::-webkit-scrollbar {
      width: 0;
    }
    &::placeholder {
      transition: transform 500ms;
      color: #767e8c;
      font-weight: 500 !important;
    }
    &:focus {
      &::placeholder {
        transform: translateX(6px);
      }
    }
  }
}
</style>
